diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
index 6ce62dc91..01e2d00c4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicActivator;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelActivator<T extends BlockLogic> extends BlockModelVeryRotatable<T> {
     public final IconCoordinate[] poweredTextures = {
@@ -32,7 +33,7 @@ public class BlockModelActivator<T extends BlockLogic> extends BlockModelVeryRot
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         if ((data & BlockLogicActivator.MASK_POWERED) != 0) {
             return poweredTextures[getRotatedSide(side, data).getId()];
@@ -42,7 +43,7 @@ public class BlockModelActivator<T extends BlockLogic> extends BlockModelVeryRot
     }
 
     @Override
-    public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data)
+    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data)
     {
         boolean isPowered = (data & BlockLogicActivator.MASK_POWERED) != 0;
         if (!isPowered) return null;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
index a7f25cb71..a55617fa6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
@@ -9,6 +9,7 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelAlgae<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelAlgae(Block<T> block) {
@@ -16,24 +17,24 @@ public class BlockModelAlgae<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
         float brightness = 1.0f;
         if(!LightmapHelper.isLightmapEnabled()) {
-        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
         }else {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
         }
 
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.blockAccess, x, y, z);
+        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(worldSource, x, y, z, 0);
         float red = (float)(color >> 16 & 0xff) / 255F;
         float green = (float)(color >> 8 & 0xff) / 255F;
         float blue = (float)(color & 0xff) / 255F;
 
         tessellator.setColorOpaque_F(red * brightness, green * brightness, blue * brightness);
-        IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.TOP, renderBlocks.blockAccess.getBlockMetadata(x, y, z));
-        renderTopFace(tessellator, bounds, x, y - 0.1125, z, tex);
-        renderBottomFace(tessellator, bounds, x, y + 0.0125, z, tex);
+        IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.TOP, worldSource.getBlockMetadata(x, y, z));
+        renderBlocks.renderTopFace(tessellator, bounds, x, y - 0.1125, z, tex);
+        renderBlocks.renderBottomFace(tessellator, bounds, x, y + 0.0125, z, tex);
 
         return true;
     }
@@ -42,9 +43,9 @@ public class BlockModelAlgae<T extends BlockLogic> extends BlockModelStandard<T>
         return false;
     }
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
     {
-        if(side == 1)
+        if(side == Side.TOP)
         {
             return true;
         } else
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
index 4770216a6..a4133ec8c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
@@ -9,6 +9,9 @@ import net.minecraft.core.block.BlockLogicAxisAligned;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelAxisAligned<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelAxisAligned(Block<T> block) {
@@ -16,8 +19,8 @@ public class BlockModelAxisAligned<T extends BlockLogic> extends BlockModelStand
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        int meta = worldSource.getBlockMetadata(x, y, z);
         Axis axis = BlockLogicAxisAligned.metaToAxis(meta);
         switch(axis)
         {
@@ -40,14 +43,14 @@ public class BlockModelAxisAligned<T extends BlockLogic> extends BlockModelStand
                 renderBlocks.uvRotateBottom = 1;
                 break;
         }
-        renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z);
-        resetRenderBlocks();
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z);
+        renderBlocks.resetRenderBlocks();
 
         return true;
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         if ((6 * (data & 3) + side.getId()) >= Sides.orientationLookUpXYZAligned.length) return TextureRegistry.getTexture("minecraft:block/grass_top");
         return super.getBlockTextureFromSideAndMetadata(Side.getSideById(Sides.orientationLookUpXYZAligned[6 * (data & 3) + side.getId()]), data);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
index b95b4ed92..d80fe57bf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
@@ -7,6 +7,8 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicBasket;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelBasket<T extends BlockLogicBasket> extends BlockModelStandard<T> {
     protected IconCoordinate fillTexture = TextureRegistry.getTexture("minecraft:block/basket/fill");
@@ -15,7 +17,7 @@ public class BlockModelBasket<T extends BlockLogicBasket> extends BlockModelStan
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         AABB bounds = block.getBounds();
         // Render basket
         final float onePix = 1.0f / 16;
@@ -23,32 +25,32 @@ public class BlockModelBasket<T extends BlockLogicBasket> extends BlockModelStan
 
         // Basket walls
         bounds.set(0, 0, 0, 1, onePix, 1);
-        renderStandardBlock(tessellator, bounds, x, y, z); // Bottom
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // Bottom
 
-        setRenderSide(Side.EAST, false);
-        setRenderSide(Side.WEST, false);
-        setRenderSide(Side.BOTTOM, false);
+        renderBlocks.setRenderSide(Side.EAST, false);
+        renderBlocks.setRenderSide(Side.WEST, false);
+        renderBlocks.setRenderSide(Side.BOTTOM, false);
         bounds.set(0, 0, 0, 1, basketHeight, onePix);
-        renderStandardBlock(tessellator, bounds, x, y, z); // North
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // North
         bounds.set(0, 0, 1 - onePix, 1, basketHeight, 1); // south
-        renderStandardBlock(tessellator, bounds, x, y, z); // South
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // South
         renderBlocks.renderBitMask = 0;
 
-        setRenderSide(Side.NORTH, false);
-        setRenderSide(Side.SOUTH, false);
-        setRenderSide(Side.BOTTOM, false);
+        renderBlocks.setRenderSide(Side.NORTH, false);
+        renderBlocks.setRenderSide(Side.SOUTH, false);
+        renderBlocks.setRenderSide(Side.BOTTOM, false);
         bounds.set(0, 0, 0, onePix, basketHeight, 1);
-        renderStandardBlock(tessellator, bounds, x, y, z); // West
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // West
         bounds.set(1 - onePix, 0, 0, 1, basketHeight, 1);
-        renderStandardBlock(tessellator, bounds, x, y, z); // East
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // East
         bounds.set(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
         renderBlocks.renderBitMask = 0;
 
-        final int height = block.getLogic().getFillLevel(renderBlocks.blockAccess, x, y, z);
+        final int height = block.getLogic().getFillLevel(worldSource, x, y, z);
         // Interior
         if (height > 0)
         {
-            renderTopFace(tessellator, bounds, x, (y - 1) + onePix + onePix * height, z, fillTexture);
+            renderBlocks.renderTopFace(tessellator, bounds, x, (y - 1) + onePix + onePix * height, z, fillTexture);
         }
 
         bounds.set(0, 0, 0, 1, basketHeight, 1);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
index 3976bc5cf..1287366f8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
@@ -8,6 +8,9 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicBed;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelBed<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate underTexture = TextureRegistry.getTexture("minecraft:block/bed/bottom");
@@ -24,18 +27,18 @@ public class BlockModelBed<T extends BlockLogic> extends BlockModelStandard<T> {
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
         renderBlocks.enableAO = true;
-        renderBlocks.cache.setupCache(block, renderBlocks.blockAccess, x, y, z);
+        renderBlocks.cache.setupCache(block, worldSource, x, y, z);
 
-        final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        final int meta = worldSource.getBlockMetadata(x, y, z);
         final int direction = BlockLogicBed.getDirection(meta);
         final boolean isFootOfBed = BlockLogicBed.isBlockFootOfBed(meta);
 
         final double minY = bounds.minY;
         bounds.minY += 0.1875D;
-        renderSide(tessellator, bounds, x, y, z, 1f, 1f, 1f, Side.BOTTOM, meta);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1f, 1f, 1f, Side.BOTTOM, meta);
         bounds.minY = minY;
 
         if(direction == 0)
@@ -50,35 +53,35 @@ public class BlockModelBed<T extends BlockLogic> extends BlockModelStandard<T> {
         {
             renderBlocks.uvRotateTop = 3;
         }
-        renderSide(tessellator, bounds, x, y, z, Side.TOP, meta);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.TOP, meta);
 
         renderBlocks.uvRotateTop = 0;
         final int f17 = isFootOfBed ? BlockLogicBed.headOfBedMap[BlockLogicBed.footToHeadMap[direction]] : BlockLogicBed.headOfBedMap[direction];
 
-        if(f17 != 2 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y, z - 1, 2)))
+        if(f17 != 2 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, x, y, z - 1, Side.NORTH)))
         {
             renderBlocks.flipTexture = direction == 3;
-            renderSide(tessellator, bounds, x, y, z, Side.NORTH, meta);
+            renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.NORTH, meta);
         }
 
-        if(f17 != 3 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y, z + 1, 3)))
+        if(f17 != 3 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, x, y, z + 1, Side.SOUTH)))
         {
             renderBlocks.flipTexture = direction == 1;
-            renderSide(tessellator, bounds, x, y, z, Side.SOUTH, meta);
+            renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.SOUTH, meta);
         }
 
-        if(f17 != 4 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, bounds, x - 1, y, z, 4)))
+        if(f17 != 4 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, x - 1, y, z, Side.WEST)))
         {
             renderBlocks.flipTexture = direction == 2;
-            renderSide(tessellator, bounds, x, y, z, Side.WEST, meta);
+            renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.WEST, meta);
         }
 
-        if(f17 != 5 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, bounds, x + 1, y, z, 5)))
+        if(f17 != 5 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, x + 1, y, z, Side.EAST)))
         {
             renderBlocks.flipTexture = direction == 0;
-            renderSide(tessellator, bounds, x, y, z, Side.EAST, meta);
+            renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.EAST, meta);
         }
-        resetRenderBlocks();
+        renderBlocks.resetRenderBlocks();
         return true;
     }
     @Override
@@ -87,7 +90,7 @@ public class BlockModelBed<T extends BlockLogic> extends BlockModelStandard<T> {
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
         if(side == Side.BOTTOM) {
             return underTexture;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
index e19c412a0..48144a44c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
@@ -9,6 +9,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -23,36 +24,36 @@ public class BlockModelBrazier<T extends BlockLogicBrazier>
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         tessellator.setColorOpaque_I(0xFFFFFF);
 
         renderBlocks.enableAO = true;
-        renderBlocks.cache.setupCache(block, renderBlocks.blockAccess, x, y, z);
+        renderBlocks.cache.setupCache(block, worldSource, x, y, z);
         AABB bounds = block.getBounds();
-        renderSide(tessellator, bounds, x, y, z, Side.NORTH, 0);
-        renderSide(tessellator, bounds, x, y, z, Side.SOUTH, 0);
-        renderSide(tessellator, bounds, x, y, z, Side.EAST, 0);
-        renderSide(tessellator, bounds, x, y, z, Side.WEST, 0);
-        renderSide(tessellator, bounds, x, y, z, Side.BOTTOM, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.NORTH, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.SOUTH, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.EAST, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.WEST, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.BOTTOM, 0);
 
         final double zFightOffset = 0.005;
         bounds.set(-zFightOffset, -zFightOffset, -zFightOffset, 1 + zFightOffset, 1 + zFightOffset, 1 + zFightOffset);
-        renderSide(tessellator, bounds, x, y, z + 1, Side.NORTH, 0);
-        renderSide(tessellator, bounds, x, y, z - 1, Side.SOUTH, 0);
-        renderSide(tessellator, bounds, x - 1, y, z, Side.EAST, 0);
-        renderSide(tessellator, bounds, x + 1, y, z, Side.WEST, 0);
-        renderSide(tessellator, bounds, x, y - 1, z, Side.TOP, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z + 1, 0, 0, 0, Side.NORTH, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z - 1, 0, 0, 0, Side.SOUTH, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x - 1, y, z, 0, 0, 0, Side.EAST, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x + 1, y, z, 0, 0, 0, Side.WEST, 0);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y - 1, z, 0, 0, 0, Side.TOP, 0);
         renderBlocks.enableAO = false;
 
         if (block.getLogic().isBurning()) {
-            fireModel.render(tessellator, x, y, z);
+            fireModel.render(tessellator, worldSource, x, y, z);
         }
 
         return true;
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         AABB bounds = block.getBounds();
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
@@ -60,59 +61,59 @@ public class BlockModelBrazier<T extends BlockLogicBrazier>
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, baseTexture);
+        renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, baseTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, bounds, 0.0D, -1.0D, 0.0D, baseTexture);
+        renderBlocks.renderTopFace(tessellator, bounds, 0.0D, -1.0D, 0.0D, baseTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 1.0D, sideTexture);
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 1.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, -1.0D, sideTexture);
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, -1.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, bounds, 1.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderWestFace(tessellator, bounds, 1.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, bounds, -1.0D, 0.0D, 0.0D, sideTexture);
+        renderBlocks.renderEastFace(tessellator, bounds, -1.0D, 0.0D, 0.0D, sideTexture);
         tessellator.draw();
 
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side) {
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side) {
         return true;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
index 44b362410..55dd58cd8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
@@ -6,6 +6,8 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -15,29 +17,29 @@ public class BlockModelCactus<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         final float sidesOffset = 0.0625F;
 
         AABB bounds = block.getBounds();
         bounds.set(sidesOffset, 0, 0, 1 - sidesOffset, 1, 1);
-        setRenderSide(Side.SOUTH, false);
-        setRenderSide(Side.NORTH, false);
-        renderStandardBlock(tessellator, bounds, x, y, z);
+        renderBlocks.setRenderSide(Side.SOUTH, false);
+        renderBlocks.setRenderSide(Side.NORTH, false);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         renderBlocks.renderBitMask = 0b111111;
 
         bounds.set(0, 0, sidesOffset, 1, 1, 1 - sidesOffset);
-        setRenderSide(Side.SOUTH, true);
-        setRenderSide(Side.NORTH, true);
-        renderStandardBlock(tessellator, bounds, x, y, z);
+        renderBlocks.setRenderSide(Side.SOUTH, true);
+        renderBlocks.setRenderSide(Side.NORTH, true);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         renderBlocks.renderBitMask = 0;
 
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate){
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate){
         if(renderBlocks.useInventoryTint)
         {
-            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
             float r = (float)(color >> 16 & 0xff) / 255F;
             float g = (float)(color >> 8 & 0xff) / 255F;
             float b = (float)(color & 0xff) / 255F;
@@ -51,39 +53,39 @@ public class BlockModelCactus<T extends BlockLogic> extends BlockModelStandard<T
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
+        renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
+        renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
         tessellator.offsetTranslation(0.0F, 0.0F, sidesOffset);
-        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
         tessellator.offsetTranslation(0.0F, 0.0F, -sidesOffset);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
         tessellator.offsetTranslation(0.0F, 0.0F, -sidesOffset);
-        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
         tessellator.offsetTranslation(0.0F, 0.0F, sidesOffset);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
         tessellator.offsetTranslation(sidesOffset, 0.0F, 0.0F);
-        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
+        renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
         tessellator.offsetTranslation(-sidesOffset, 0.0F, 0.0F);
         tessellator.draw();
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         tessellator.offsetTranslation(-sidesOffset, 0.0F, 0.0F);
-        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
+        renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
         tessellator.offsetTranslation(sidesOffset, 0.0F, 0.0F);
         tessellator.draw();
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
index 47b31a82d..6086aa3ab 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelCake<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate cakeInner = TextureRegistry.getTexture("minecraft:block/cake/inner");
@@ -16,7 +17,7 @@ public class BlockModelCake<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         if(data > 0 && side == Side.WEST)
         {
